/*************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 * Copyright 2008 by Nakata, Maho
 * 
 * $Id: mblas.h,v 1.11 2009/09/24 18:00:34 nakatamaho Exp $ 
 *
 * MPACK - multiple precision arithmetic library
 *
 * This file is part of MPACK.
 *
 * MPACK is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * MPACK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with MPACK.  If not, see
 * <http://www.gnu.org/licenses/lgpl.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/

#ifndef _MBLAS_H_
#define _MBLAS_H_

#if defined ___MPACK_BUILD_WITH_GMP___
#include <mblas_gmp.h>
typedef mpackint INTEGER;
typedef mpc_class COMPLEX;
typedef mpf_class REAL;
#define Mlsame   Mlsame_gmp
#define Mxerbla  Mxerbla_gmp 
#endif

#if defined ___MPACK_BUILD_WITH_QD___
#include <mblas_qd.h>
typedef mpackint INTEGER;
typedef qd_real REAL;
typedef qd_complex COMPLEX;
#define Mlsame   Mlsame_qd
#define Mxerbla  Mxerbla_qd
#endif

#if defined ___MPACK_BUILD_WITH_DD___
#include <mblas_dd.h>
typedef mpackint INTEGER;
typedef dd_real REAL;
typedef dd_complex COMPLEX;
#define Mlsame   Mlsame_dd
#define Mxerbla  Mxerbla_dd
#endif

using std::max;
using std::min;

#endif
